/*-
 * ~~~~~~licensing~~~~~~
 * artifact-management
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.artifact.installer.builder.impl;

import ru.entaxy.platform.core.artifact.installer.ArtifactInstaller;
import ru.entaxy.platform.core.artifact.installer.builder.ClusterInstaller;
import ru.entaxy.platform.core.artifact.installer.builder.Installers;
import ru.entaxy.platform.core.artifact.installer.builder.LocalInstaller;
import ru.entaxy.platform.core.artifact.installer.builder.impl.cluster.ClusterInstallerWrapperImpl;

public class InstallersImpl implements Installers {

	protected ArtifactInstaller<LocalInstaller> local = null;
	protected ArtifactInstaller<ClusterInstaller> cluster = null;

	protected boolean localOnlyMode = false;
	
	@Override
	public LocalInstaller local() {
		if (local == null)
			// TODO throw exception
			return null;
		return local.createInstaller();
	}

	@Override
	public ClusterInstaller cluster(String... groupName) {
		if (this.localOnlyMode)
			return new ClusterInstallerWrapperImpl(this.local());
		if (cluster == null)
			// TODO throw exception
			return null;
		return cluster.createInstaller().groups(groupName);
	}

	public ArtifactInstaller<LocalInstaller> getLocal() {
		return local;
	}

	public void setLocal(ArtifactInstaller<LocalInstaller> local) {
		this.local = local;
	}

	public ArtifactInstaller<ClusterInstaller> getCluster() {
		return cluster;
	}

	public void setCluster(ArtifactInstaller<ClusterInstaller> cluster) {
		this.cluster = cluster;
	}

	public boolean isLocalOnlyMode() {
		return localOnlyMode;
	}

	public void setLocalOnlyMode(boolean localOnlyMode) {
		this.localOnlyMode = localOnlyMode;
	}
	
}
